summaryrefslogtreecommitdiff
path: root/run_tests.sh
diff options
context:
space:
mode:
authorBrian Waldon <bcwaldon@gmail.com>2012-03-26 22:48:48 -0700
committerBrian Waldon <bcwaldon@gmail.com>2012-03-26 22:48:48 -0700
commitc530de638916d29c609f66194569f57234a68289 (patch)
treee44cfc2791b8bf2932573e4a9157cc6144d59d72 /run_tests.sh
parentb5847df3e203ec83126a3cc903bca58093399b89 (diff)
downloadpython-glanceclient-c530de638916d29c609f66194569f57234a68289.tar.gz
Basic get/list operations work
* 'glance image-list' and 'glance image-show' work * Set up tests, pep8, venv
Diffstat (limited to 'run_tests.sh')
-rwxr-xr-xrun_tests.sh96
1 files changed, 19 insertions, 77 deletions
diff --git a/run_tests.sh b/run_tests.sh
index 731d298..d0d3645 100755
--- a/run_tests.sh
+++ b/run_tests.sh
@@ -1,21 +1,15 @@
#!/bin/bash
-set -eu
-
function usage {
echo "Usage: $0 [OPTION]..."
- echo "Run python-glanceclient test suite"
+ echo "Run python-glanceclient's test suite(s)"
echo ""
echo " -V, --virtual-env Always use virtualenv. Install automatically if not present"
echo " -N, --no-virtual-env Don't use virtualenv. Run tests in local environment"
- echo " -s, --no-site-packages Isolate the virtualenv from the global Python environment"
- echo " -x, --stop Stop running tests after the first error or failure."
echo " -f, --force Force a clean re-build of the virtual environment. Useful when dependencies have been added."
+ echo " --unittests-only Run unit tests only, exclude functional tests."
echo " -p, --pep8 Just run pep8"
- echo " -P, --no-pep8 Don't run pep8"
- echo " -c, --coverage Generate coverage report"
echo " -h, --help Print this usage message"
- echo " --hide-elapsed Don't print the elapsed time for each test along with slow test list"
echo ""
echo "Note: with no options specified, the script will try to run the tests in a virtual environment,"
echo " If no virtualenv is found, the script will ask if you would like to create one. If you "
@@ -26,14 +20,10 @@ function usage {
function process_option {
case "$1" in
-h|--help) usage;;
- -V|--virtual-env) always_venv=1; never_venv=0;;
- -N|--no-virtual-env) always_venv=0; never_venv=1;;
- -s|--no-site-packages) no_site_packages=1;;
- -f|--force) force=1;;
- -p|--pep8) just_pep8=1;;
- -P|--no-pep8) no_pep8=1;;
- -c|--coverage) coverage=1;;
- -*) noseopts="$noseopts $1";;
+ -V|--virtual-env) let always_venv=1; let never_venv=0;;
+ -N|--no-virtual-env) let always_venv=0; let never_venv=1;;
+ -p|--pep8) let just_pep8=1;;
+ -f|--force) let force=1;;
*) noseargs="$noseargs $1"
esac
}
@@ -43,61 +33,29 @@ with_venv=tools/with_venv.sh
always_venv=0
never_venv=0
force=0
-no_site_packages=0
-installvenvopts=
noseargs=
-noseopts=
wrapper=""
just_pep8=0
-no_pep8=0
-coverage=0
for arg in "$@"; do
process_option $arg
done
-# If enabled, tell nose to collect coverage data
-if [ $coverage -eq 1 ]; then
- noseopts="$noseopts --with-coverage --cover-package=keystoneclient"
-fi
-
-if [ $no_site_packages -eq 1 ]; then
- installvenvopts="--no-site-packages"
-fi
-
function run_tests {
# Just run the test suites in current environment
- ${wrapper} $NOSETESTS
- # If we get some short import error right away, print the error log directly
- RESULT=$?
- return $RESULT
+ ${wrapper} rm -f tests.sqlite
+ ${wrapper} $NOSETESTS 2> run_tests.err.log
}
function run_pep8 {
- echo "Running pep8 ..."
- srcfiles="keystoneclient tests"
- # Just run PEP8 in current environment
- #
- # NOTE(sirp): W602 (deprecated 3-arg raise) is being ignored for the
- # following reasons:
- #
- # 1. It's needed to preserve traceback information when re-raising
- # exceptions; this is needed b/c Eventlet will clear exceptions when
- # switching contexts.
- #
- # 2. There doesn't appear to be an alternative, "pep8-tool" compatible way of doing this
- # in Python 2 (in Python 3 `with_traceback` could be used).
- #
- # 3. Can find no corroborating evidence that this is deprecated in Python 2
- # other than what the PEP8 tool claims. It is deprecated in Python 3, so,
- # perhaps the mistake was thinking that the deprecation applied to Python 2
- # as well.
- ${wrapper} pep8 --repeat --show-pep8 --show-source \
- --ignore=E202,W602 \
- ${srcfiles}
+ echo "Running pep8..."
+ PEP8_OPTIONS="--exclude=$PEP8_EXCLUDE --repeat"
+ PEP8_INCLUDE="glanceclient/* setup.py run_tests.py tools/install_venv.py"
+ ${wrapper} pep8 $PEP8_OPTIONS $PEP8_INCLUDE
}
-NOSETESTS="nosetests $noseopts $noseargs"
+
+NOSETESTS="python run_tests.py $noseargs"
if [ $never_venv -eq 0 ]
then
@@ -111,43 +69,27 @@ then
else
if [ $always_venv -eq 1 ]; then
# Automatically install the virtualenv
- python tools/install_venv.py $installvenvopts
+ python tools/install_venv.py
wrapper="${with_venv}"
else
echo -e "No virtual environment found...create one? (Y/n) \c"
read use_ve
if [ "x$use_ve" = "xY" -o "x$use_ve" = "x" -o "x$use_ve" = "xy" ]; then
# Install the virtualenv and run the test suite in it
- python tools/install_venv.py $installvenvopts
- wrapper=${with_venv}
+ python tools/install_venv.py
+ wrapper=${with_venv}
fi
fi
fi
fi
-# Delete old coverage data from previous runs
-if [ $coverage -eq 1 ]; then
- ${wrapper} coverage erase
-fi
-
if [ $just_pep8 -eq 1 ]; then
run_pep8
exit
fi
-run_tests
+run_tests || exit
-# NOTE(sirp): we only want to run pep8 when we're running the full-test suite,
-# not when we're running tests individually. To handle this, we need to
-# distinguish between options (noseopts), which begin with a '-', and
-# arguments (noseargs).
if [ -z "$noseargs" ]; then
- if [ $no_pep8 -eq 0 ]; then
- run_pep8
- fi
-fi
-
-if [ $coverage -eq 1 ]; then
- echo "Generating coverage report in covhtml/"
- ${wrapper} coverage html -d covhtml -i
+ run_pep8
fi